<?php
/**
 * ------------------------------------------------------------------------
 * BlueMind Stats Portal, aka bm-stats
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
 * ------------------------------------------------------------------------
 **/
 
function dom_to_simple_array($domnode, &$array) {
        $array_ptr = &$array;
        $domnode = $domnode->firstChild;
        while (!is_null($domnode)) {
                if (! (trim($domnode->nodeValue) == "") ) {
                        switch ($domnode->nodeType) {
                                case XML_TEXT_NODE: 
                                {
                                        $array_ptr['cdata'] = $domnode->nodeValue;
                                        break;
                                };
                                case XML_ELEMENT_NODE:  
                                {
                                        $array_ptr = &$array[$domnode->nodeName][];
                                        if ($domnode->hasAttributes() ) {
                                                $attributes = $domnode->attributes;
                                                if (!is_array ($attributes)) {
                                                        break;
                                                };
                                                foreach ($attributes as $index => $domobj) {
                                                        $array_ptr[$index] = $array_ptr[$domobj->name] = $domobj->value;
                                                };
                                        };
                                        break;
                                };
                        };
                        if ( $domnode->hasChildNodes() ) {
                                dom_to_simple_array($domnode, $array_ptr);
                        };
                } ;
                $domnode = $domnode->nextSibling;
        };
} ;


function print_in_KMGT_octet($bytes) {
 
     $precision = 2 ;
 
     $units = array('B', 'KB', 'MB', 'GB', 'TB'); 
 
     $bytes = max($bytes, 0); 
     $pow = floor(($bytes ? log($bytes) : 0) / log(1024)); 
     $pow = min($pow, count($units) - 1); 
 
     $bytes /= pow(1024, $pow); 
 
    return round($bytes, $precision) . ' ' . $units[$pow]; 
}

/*
Stat by outgoing user
*/

function parse_xml_file($resm) {
        Global $path_to_resume_xml,$max_element_in_top ;

        $file = $path_to_resume_xml."$resm.xml";
        $this_array = array();
        if(is_file($file)) {
        	$dom = new DomDocument ;
        	$dom -> load($file);

        	$data = array();

        	dom_to_simple_array($dom,$data);

        	$TopMailSent_temp = $data['statsbyuser'][0]['TopMailSent'][0][user];
                if(!empty($TopMailSent_temp)) {

                        $TopMailSent = array_slice($TopMailSent_temp,0,$max_element_in_top);
                        foreach($TopMailSent as $entry) {
                                $key = $entry['name']['0'][cdata];
                                $nb  = $entry['mailSent']['0'][cdata];
                                $vol = $entry['mailSentTotalSize']['0'][cdata];

                                $this_array[TopMailSent]["$key"][nb]  = $nb ;
                                $this_array[TopMailSent]["$key"][vol] = $vol;
                        };
                };



                $TopMailSentTotalSize_temp = $data['statsbyuser'][0]['TopMailSentTotalSize'][0][user];

                if(!empty($TopMailSentTotalSize_temp)) {

                        $TopMailSentTotalSize = array_slice($TopMailSentTotalSize_temp,0,$max_element_in_top);

                        foreach($TopMailSentTotalSize as $entry) {
                                $key = $entry['name']['0'][cdata];
                                $nb  = $entry['mailSent']['0'][cdata];
                                $vol = $entry['mailSentTotalSize']['0'][cdata];

                                $this_array[TopMailSentTotalSize]["$key"][nb]  = $nb ;
                                $this_array[TopMailSentTotalSize]["$key"][vol] = $vol;
                        };
                };

	};

    return $this_array;

};


function display_mail_stat_by_user($resm,$case) {

    Global $pdfreport_Activity, $pdfreport_accountActivity ,$pdfreport_accountSentNb, $pdfreport_accountSentVolume ,$pdfreport_while ,$pdfreport_xmlAccount ;
    Global $pdfreport_while ;	

    if(empty($resm) or strlen($date) != "7" or preg_match("/$\d{4}_\d{2}^/",$resm) ) {
        $resm = date("Y_m",mktime(0,0,0,date("m"),date("d")-1,date("Y") ));
    };

	if($res = parse_xml_file($resm)) {
        $part = explode("_",$resm); 
        $when = "$pdfreport_while ".get_month($part[1])." ".$part[0];

		if ($case == "TopMailSent" ) {
                        $block .= '<b>'.$pdfreport_Activity.' '.$when.'</b><br>
                        <br>
                        <table width="96%" border="1" cellpadding="1" cellspacing="0">
                        <tr>
                        <td width="60%" bgcolor="#21689e">&nbsp;&nbsp; <b>'.$pdfreport_xmlAccount.' </b></td>
                        <td align="center" width="20%" bgcolor="#21689e" ><b>'.$pdfreport_accountSentNb.'</b></td>
                        <td align="center" width="20%" bgcolor="#21689e" ><b>'.$pdfreport_accountSentVolume.'</b></td>
                        </tr>';
                        foreach ( array_keys($res[TopMailSent]) as $key) {
                                $block .= '<tr>
                                <td width="60%">&nbsp;&nbsp; '.str_replace("\\","",$key).'</td>
                                <td align="center" width="20%" bgcolor="#21689e">'.$res[TopMailSent][$key]['nb'].'</td>
                                <td align="center" width="20%" bgcolor="">'.print_in_KMGT_octet($res[TopMailSent][$key]['vol']).'</td>
                                </tr>';
                        };
                        $block .='</table>';


		} else {

                	$block .= '<b>'.$pdfreport_Activity.' '.$when.'</b><br>
			<br>
                	<table width="96%" border="1" cellpadding="1" cellspacing="0">
                	<tr>
               	 	<td width="60%" bgcolor="#21689e">&nbsp;&nbsp; <b>'.$pdfreport_xmlAccount.'</b></td>
                	<td align="center" width="20%" bgcolor="#21689e" ><b>'.$pdfreport_accountSentNb.'</b></td>
                	<td align="center" width="20%" bgcolor="#21689e" ><b>'.$pdfreport_accountSentVolume.'</b></td>
                	</tr>';
                	foreach ( array_keys($res[TopMailSentTotalSize]) as $key) {
                        	$block .= '<tr>
                        	<td width="60%">&nbsp;&nbsp; '.str_replace("\\","",$key).'</td>
                        	<td align="center" width="20%">'.$res[TopMailSentTotalSize][$key]['nb'].'</td>
                        	<td align="center" width="20%" bgcolor="#21689e">'.print_in_KMGT_octet($res[TopMailSentTotalSize][$key]['vol']).'</td>
                        	</tr>';
                	};
                	$block .='</table>';
		};

		return $block;
	};
};

/*
Stat by ingoing domain
*/

function parse_xmlDomain_file($resm) {
        Global $path_to_resume_xmlDomain,$max_element_in_top ;
        
        $file = $path_to_resume_xmlDomain."$resm.xml";
        $this_array = array();
        if(is_file($file)) {

		$dom = new DomDocument ;
        	$dom -> load($file);

        	$data = array();

        	dom_to_simple_array($dom,$data);

        	$TopMailSent_temp = $data['statsbyuser'][0]['TopMailSent'][0][user];
		
		if(!empty($TopMailSent_temp)) {
	
			$TopMailSent = array_slice($TopMailSent_temp,0,$max_element_in_top);
	                foreach($TopMailSent as $entry) {
	                        $key = $entry['name']['0'][cdata];
        	                $nb  = $entry['mailSent']['0'][cdata];
                	        $vol = $entry['mailSentTotalSize']['0'][cdata];

                        	$this_array[TopMailSent]["$key"][nb]  = $nb ;
                        	$this_array[TopMailSent]["$key"][vol] = $vol;
			};
                };



		$TopMailSentTotalSize_temp = $data['statsbyuser'][0]['TopMailSentTotalSize'][0][user];
            	
		if(!empty($TopMailSentTotalSize_temp)) {
		
			$TopMailSentTotalSize = array_slice($TopMailSentTotalSize_temp,0,$max_element_in_top);      

        		foreach($TopMailSentTotalSize as $entry) {
               	 		$key = $entry['name']['0'][cdata];
                		$nb  = $entry['mailSent']['0'][cdata];
                		$vol = $entry['mailSentTotalSize']['0'][cdata];
                
                		$this_array[TopMailSentTotalSize]["$key"][nb]  = $nb ;
                		$this_array[TopMailSentTotalSize]["$key"][vol] = $vol; 
        		};
		};
	};

    return $this_array;

};


function display_mail_stat_by_domain($resm,$case) {

    Global $pdfreport_Activity, $pdfreport_domainActivity ,$pdfreport_xmlDomain,$pdfreport_while ;
    Global $pdfreport_incomingDomainNb,$pdfreport_incomingDomainVolume ;	

    if(empty($resm) or strlen($date) != "7" or preg_match("/$\d{4}_\d{2}^/",$resm) ) {
    $resm = date("Y_m",mktime(0,0,0,date("m"),date("d")-1,date("Y") ));
    };
	
    if($res = parse_xmlDomain_file($resm)) {
    
        $part = explode("_",$resm); 
        $when = "$pdfreport_while ".get_month($part[1])." ".$part[0];

		if ($case == "TopMailSent" ) {
                        $block .= '<b>'.$pdfreport_Activity.' '.$when.'</b><br>
                        <br>
                        <table width="96%" border="1" cellpadding="1" cellspacing="0">
                        <tr>
                        <td width="60%" bgcolor="#21689e">&nbsp;&nbsp; <b>'.$pdfreport_xmlDomain.' </b></td>
                        <td align="center" width="20%" bgcolor="#21689e" ><b>'.$pdfreport_incomingDomainNb.'</b></td>
                        <td align="center" width="20%" bgcolor="#21689e" ><b>'.$pdfreport_incomingDomainVolume.'</b></td>
                        </tr>';
                        foreach ( array_keys($res[TopMailSent]) as $key) {
                                $block .= '<tr>
                                <td width="60%">&nbsp;&nbsp; '.str_replace("\\","",$key).'</td>
                                <td align="center" width="20%" bgcolor="#21689e">'.$res[TopMailSent][$key]['nb'].'</td>
                                <td align="center" width="20%" bgcolor="">'.print_in_KMGT_octet($res[TopMailSent][$key]['vol']).'</td>
                                </tr>';
                        };
                        $block .='</table>';


		} else {

                	$block .= '<b>'.$pdfreport_Activity.' '.$when.'</b><br>
			<br>
                	<table width="96%" border="1" cellpadding="1" cellspacing="0">
                	<tr>
               	 	<td width="60%" bgcolor="#21689e">&nbsp;&nbsp; <b>'.$pdfreport_xmlDomain.'</b></td>
                	<td align="center" width="20%" bgcolor="#21689e" ><b>'.$pdfreport_incomingDomainNb.'</b></td>
                	<td align="center" width="20%" bgcolor="#21689e" ><b>'.$pdfreport_incomingDomainVolume.'</b></td>
                	</tr>';
                	foreach ( array_keys($res[TopMailSentTotalSize]) as $key) {
                        	$block .= '<tr>
                        	<td width="60%">&nbsp;&nbsp; '.str_replace("\\","",$key).'</td>
                        	<td align="center" width="20%">'.$res[TopMailSentTotalSize][$key]['nb'].'</td>
                        	<td align="center" width="20%" bgcolor="#21689e">'.print_in_KMGT_octet($res[TopMailSentTotalSize][$key]['vol']).'</td>
                        	</tr>';
                	};
                	$block .='</table>';
		};

		return $block;
	};
};

/*
Stat by outgoing domain
*/

function parse_xmlDomainOutgoing_file($resm) {
        Global $path_to_resume_xmlDomainOutgoing,$max_element_in_top ;

        $file = $path_to_resume_xmlDomainOutgoing."$resm.xml";
        $this_array = array();
        if(is_file($file)) {

                $dom = new DomDocument ;
                $dom -> load($file);

                $data = array();

                dom_to_simple_array($dom,$data);

                $TopMailSent_temp = $data['statsbyuser'][0]['TopMailSent'][0][user];

                if(!empty($TopMailSent_temp)) {

                        $TopMailSent = array_slice($TopMailSent_temp,0,$max_element_in_top);
                        foreach($TopMailSent as $entry) {
                                $key = $entry['name']['0'][cdata];
                                $nb  = $entry['mailSent']['0'][cdata];
                                $vol = $entry['mailSentTotalSize']['0'][cdata];

                                $this_array[TopMailSent]["$key"][nb]  = $nb ;
                                $this_array[TopMailSent]["$key"][vol] = $vol;
                        };
                };



                $TopMailSentTotalSize_temp = $data['statsbyuser'][0]['TopMailSentTotalSize'][0][user];

                if(!empty($TopMailSentTotalSize_temp)) {

                        $TopMailSentTotalSize = array_slice($TopMailSentTotalSize_temp,0,$max_element_in_top);

                        foreach($TopMailSentTotalSize as $entry) {
                                $key = $entry['name']['0'][cdata];
                                $nb  = $entry['mailSent']['0'][cdata];
                                $vol = $entry['mailSentTotalSize']['0'][cdata];

                                $this_array[TopMailSentTotalSize]["$key"][nb]  = $nb ;
                                $this_array[TopMailSentTotalSize]["$key"][vol] = $vol;
                        };
                };
        };

    return $this_array;

};

function display_mail_stat_by_domain_outgoing($resm,$case) {

    Global $pdfreport_Activity, $pdfreport_domainActivity ,$pdfreport_xmlDomain,$pdfreport_while ;
    Global $pdfreport_outgoingDomainNb,$pdfreport_outgoingDomainVolume ;


    if(empty($resm) or strlen($date) != "7" or preg_match("/$\d{4}_\d{2}^/",$resm) ) {
    $resm = date("Y_m",mktime(0,0,0,date("m"),date("d")-1,date("Y") ));
    };

    if($res = parse_xmlDomainOutgoing_file($resm)) {

        $part = explode("_",$resm); 
        $when = "$pdfreport_while ".get_month($part[1])." ".$part[0];

                if ($case == "TopMailSent" ) {
                        $block .= '<b>'.$pdfreport_Activity.' '.$when.'</b><br>
                        <br>
                        <table width="96%" border="1" cellpadding="1" cellspacing="0">
                        <tr>
                        <td width="60%" bgcolor="#21689e">&nbsp;&nbsp; <b>'.$pdfreport_xmlDomain.' </b></td>
                        <td align="center" width="20%" bgcolor="#21689e" ><b>'.$pdfreport_outgoingDomainNb.'</b></td>
                        <td align="center" width="20%" bgcolor="#21689e" ><b>'.$pdfreport_outgoingDomainVolume.'</b></td>
                        </tr>';
                        foreach ( array_keys($res[TopMailSent]) as $key) {
                                $block .= '<tr>
                                <td width="60%">&nbsp;&nbsp; '.str_replace("\\","",$key).'</td>
                                <td align="center" width="20%" bgcolor="#21689e">'.$res[TopMailSent][$key]['nb'].'</td>
                                <td align="center" width="20%" bgcolor="">'.print_in_KMGT_octet($res[TopMailSent][$key]['vol']).'</td>
                                </tr>';
                        };
                        $block .='</table>';


                } else {

                        $block .= '<b>'.$pdfreport_Activity.' '.$when.'</b><br>
                        <br>
                        <table width="96%" border="1" cellpadding="1" cellspacing="0">
                        <tr>
                        <td width="60%" bgcolor="#21689e">&nbsp;&nbsp; <b>'.$pdfreport_xmlDomain.'</b></td>
                        <td align="center" width="20%" bgcolor="#21689e" ><b>'.$pdfreport_outgoingDomainNb.'</b></td>
                        <td align="center" width="20%" bgcolor="#21689e" ><b>'.$pdfreport_outgoingDomainVolume.'</b></td>
                        </tr>';
                        foreach ( array_keys($res[TopMailSentTotalSize]) as $key) {
                                $block .= '<tr>
                                <td width="60%">&nbsp;&nbsp; '.str_replace("\\","",$key).'</td>
                                <td align="center" width="20%">'.$res[TopMailSentTotalSize][$key]['nb'].'</td>
                                <td align="center" width="20%" bgcolor="#21689e">'.print_in_KMGT_octet($res[TopMailSentTotalSize][$key]['vol']).'</td>
                                </tr>';
                        };
                        $block .='</table>';
                };

                return $block;
        };
};

?>