#!/bin/bash

# **
# * ------------------------------------------------------------------------
# * BlueMind Stats Portal, aka bm-stats
# * ------------------------------------------------------------------------
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
# * @author  : Pascal SALAUN 
# * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
# * ------------------------------------------------------------------------
# **

PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
export PATH

# Author : Pascal Salaun <pascal.salaun@laposte.net>
# Description : do a logrotate of the core.log file.
# Because these one can be hugh (over 1Go/day), the current savelog command
# will take too much time. (2 minutes for a 3.5Go file)
# So, this method will take only 1-2 seconds.



CoreLogDir="/var/log/bm/"
CoreLogDestDir="/var/log/bm/"

LogDaemon="rsyslog"


# Control
if [ ! -d $CoreLogDestDir ]; then
            mkdir -p $CoreLogDestDir
            fi


# Get log daemon name (rsyslog/syslog-ng/sysklogd)
if [ "$LogDaemon" = "" ] ; then
        LogDaemon=`dpkg -l "*sys*log*" | grep ii | grep -iv perl | tr -s ' ' | cut -d ' ' -f2| grep -v system`
        fi


# Logrotate

mv $CoreLogDir"core.log.0" $CoreLogDir"core.log."`date --date '2 days ago' +%F`
mv $CoreLogDir"core.log" $CoreLogDir"core.log.0"

touch $CoreLogDir"core.log"

chown root:root $CoreLogDir"core.log"

# Restart LogDaemon
#/etc/init.d/$LogDaemon restart
service $LogDaemon restart

# renamming, compressing, archiving core.log.1
gzip -c $CoreLogDir"core.log."`date --date '2 days ago' +%F` > $CoreLogDir"core.log."`date --date '2 days ago' +%F`.gz
mv $CoreLogDir"core.log."`date --date '2 days ago' +%F`.gz $CoreLogDestDir


# deleting the uncompressed core.log.yyyy-mm-dd
rm -f  $CoreLogDir"core.log."`date --date '2 days ago' +%F`

# deleting the compressed file older than 1 year
rm -f  $CoreLogDestDir"core.log."`date --date '365 days ago' +%F`.gz

exit 0 ;

