#!/bin/bash

# **
# * ------------------------------------------------------------------------
# * BlueMind Stats Portal, aka bm-stats
# * ------------------------------------------------------------------------
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
# * @author  : Pascal SALAUN 
# * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
# * ------------------------------------------------------------------------
# **

# Case of update

chmod 644 /etc/cron.d/bm-stats 

if [ -f /usr/share/bm-stats/www/conf/config.php ] ; then
	sed -i "/^\$version/ s/\"\(.*\)\"/\"V\. 3\.1\.8\"/" /usr/share/bm-stats/www/conf/config.php
	chown root.www-data /usr/share/bm-stats/www/conf/config.php
else
	/usr/share/bm-stats/scripts/SHELL/install.sh
# 	sed -i "/^\$version/ s/\"\(.*\)\"/\"V\. 3\.1\.8\"/" /usr/share/bm-stats/www/conf/config.php
	chown root.www-data /usr/share/bm-stats/www/conf/config.php
fi

testPOSTFIX=$(grep -c -e '^mime_header.*BM_mime_header_checks' /etc/postfix/main.cf)
if [ "$testPOSTFIX" != 0 ]; then
		echo " Postfix : specific bmStats mime_header_check seems to be loaded "
	else
		echo " Saving your actual postif main.cf "
		/bin/cp /etc/postfix/main.cf "/etc/postfix/main.cf_"$(date +%Y%m%d-%H%M%S)
	
		echo "Adding postfix PCRE rules for bmStats" 
		echo "" >> /etc/postfix/main.cf
		echo "#bmStats PCRE Rules" >> /etc/postfix/main.cf
		echo "mime_header_checks= pcre:/etc/postfix/BM_mime_header_checks" >> /etc/postfix/main.cf
fi

echo "Reloading Postfix"
/etc/init.d/postfix reload

HOSTNAME=$(hostname -f) 

echo "Reloading Nginx"
/etc/init.d/nginx reload

cp /etc/nginx/sites-available/bmStats  /etc/nginx/sites-enabled/.
sed -i "s/__externalUrl__/$HOSTNAME/" /etc/nginx/sites-enabled/bmStats
/etc/init.d/nginx reload


exit 0
